// The contents of this file are subject to the Mozilla Public
// License Version 1.1 (the "License"); you may not use this file
// except in compliance with the License. You may obtain a copy of
// the License at http://www.mozilla.org/MPL/
//    
// Software distributed under the License is distributed on an "AS
// IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
// implied. See the License for the specific language governing
// rights and limitations under the License.
//    
// The Original Code is Archangel.
// The Initial Developer of the Original Code is Thomas Thurman
//    
// Portions created by Thomas Thurman are
// Copyright (C) 2002 Thomas Thurman.
// All Rights Reserved.

////////////////////////////////////////////////////////////////
//
// Yes, this code is ugly.
// I know.
// I didn't know JS before I started. It'll improve.
//
////////////////////////////////////////////////////////////////

include('chrome://jslib/content/io/dir.js');
include('chrome://jslib/content/io/dirUtils.js');

////////////////////////////////////////////////////////////////

var currentVault;

var RgtpVolatile = { 'name': 'vol', 'max': -1 };

////////////////////////////////////////////////////////////////

function stripyMeter() {
	var meter = document.getElementById('progress');
	meter.setAttribute('mode', 'undetermined');
}

function percentage(n) {
	var meter = document.getElementById('progress');
	meter.setAttribute('mode', 'determined');
	meter.setAttribute('value', Math.round(n)+'%');
}

function calmMeter() {
	percentage(0);
	setStatus('Ready');
}

////////////////////////////////////////////////////////////////

// Returns a string containing a representation of |number| in
// hex. The string is always at least eight digits long.
function hex(number) {

	if (number < 0) {
		// Safety check. Not intended to be much used.
		return "-" + hex(-number);
	}

	var temp = '';
	var digits = '0123456789abcdef';

	while (number!=0) {
		temp = digits.charAt(number & 0xF) + temp;
		number = number >> 4;
	}

	while (temp.length < 8) {
		temp = '0' + temp;
	}

	return temp;
}

////////////////////////////////////////////////////////////////

function strip(s) {
	s.replace(/\s*$/, '');
	return s;
}

function addToIndex(id, subject) {
	var holder = document.getElementById('groggs-items');
	var item = document.createElement('treeitem');
	var row = document.createElement('treerow');

	var asubject = document.createElement('treecell');

	asubject.setAttribute('label', subject);

	row.appendChild(asubject);
	item.appendChild(row);
	item.setAttribute('id', 'groggs-'+id);

	holder.appendChild(item);
}

function clearItemLines() {
	var oldDoc = document.getElementById('item-display');
	var newDoc = oldDoc.cloneNode(false);

	document.getElementById('item-scroller').replaceChild(newDoc, oldDoc);
}

html_namespace = "http://www.w3.org/1999/xhtml";

function addItemHorizontalRule() {
	var holder = document.getElementById('item-display');
	var hr = document.createElementNS(html_namespace, 'html:hr')

	holder.appendChild(hr);
}

function addItemLine(text, bold) {
	var holder = document.getElementById('item-display');

	if (bold) {
		var message = document.createTextNode(text);
		var formatting = document.createElementNS(html_namespace, 'html:b')
		formatting.appendChild(message);
		holder.appendChild(formatting);
	} else {
		var message = document.createTextNode(text);
		holder.appendChild(message);
	}

	holder.appendChild(document.createElementNS(html_namespace, 'html:br'));
}

function setStatus(s) {
	document.getElementById('status').setAttribute('value',s);
}

function send(s) {
	server.write(s+'\r\n');
}

////////////////////////////////////////////////////////////////

state = 0
server = new CConnection('rgtp-serv.groggs.group.cam.ac.uk', 1431);

var RgtpTempChildItem = null;
var RgtpTempMotd = null;
var RgtpIndex = null;
var RgtpLooseEnds = null;

////////////////////////////////////////////////////////////////

function NumericComparison(left, right) {
	var l = (left.known) * 1;
	var r = (right.known) * 1;

	if (l < r) {
		return 1;
	} else if (l == r) {
		return 0;
	} else {
		return -1;
	}
}

////////////////////////////////////////////////////////////////

function tieUpLooseEnds() {
	for (looseEnd in RgtpLooseEnds) {
		var cache = persistRecall(looseEnd);
		cache.known = RgtpLooseEnds[looseEnd];
		persistStore(cache);
	}

	RgtpLooseEnds = null;
}

////////////////////////////////////////////////////////////////

function updateTree() {
	// We need a customised tree object;
	// till then, this will do fine.
	// (The rather odd structure is caused by a
	// a design which is expecting a custom tree.)

	setStatus('Updating tree...');

	for (i in RgtpIndex.sort(NumericComparison)) {
		item = RgtpIndex[i]
		addToIndex(item.id, item.subject);
	}

	setStatus('Ready');
}


function loadIndex() {

	stripyMeter();
	setStatus('Loading cache...');

	var files = currentVault.readDir();

	// Bah. Why can't you sort associative arrays in JS?

	RgtpIndex = Array();

	for (i in files) {
		if (files[i].isFile() && files[i].leaf.length==8) {
			// Should be an itemid.
			var cached = persistRecall(files[i].leaf);
			RgtpIndex[RgtpIndex.length] =
				{ id: cached.name,
				known: cached.known,
				subject: cached.subject };
		}
	}
}

////////////////////////////////////////////////////////////////

// FIXME: Make a class for this

function handleLine(s) {
	code = ''
	if (s.length>4) {
		code = s.substring(0, 3);
	}

	switch (state) {
	case 0:
		if (code=='230') {
			stripyMeter();
			setStatus('Logging into server...');
			// For now:
			send('USER guest');
		} else if (code=='231') {
			// oo, then we can get the index!
			RgtpLooseEnds = new Array();
			RgtpVolatile = persistRecall('vol');
			if (RgtpVolatile.max) {
				send('INDX #'+hex(RgtpVolatile.max+1));
			} else {
				RgtpVolatile.max = -1;
				send('INDX');
			}
			state = 1;
		}
		break;
	case 1: // about to receive index
		if (code=='250') {
			setStatus('Receiving index...');
			state = 2;
		}
		break;
	case 2: // receiving index
		if (s=='.') {
			// end of index
			calmMeter();
			persistStore(RgtpVolatile);
			tieUpLooseEnds();
			loadIndex();
			updateTree();

			if (RgtpVolatile.motd_known>=RgtpVolatile.motd_seen) {
				// we're all done
				state = 3;
			} else {
				// hmm, show them the new MOTD
				send('MOTD');
				state = 7;
			}
		} else {
			// okay, got a line from the index here.
			// split it out.

			typecode = s.charAt(103);
			itemid = s.substring(18,26);
			sequence = eval("0x"+s.substring(0,8));
			if (sequence > RgtpVolatile.max) {
				RgtpVolatile.max = sequence;
			}

			if (typecode=='R') {
				// These are so common we don't even
				// write them out.
				RgtpLooseEnds[itemid] = sequence;
			} else if (typecode=='I' || typecode=='C') {
				var store = persistRecall(itemid);
				store.subject = s.substring(105);
				store.known = sequence;
				persistStore(store);

				if (typecode=='C') {
					// This is a continuation, but
					// we don't yet know what it's a
					// continuation of.
					RgtpTempChildItem = itemid;
				}

			} else if (typecode=='F' && RgtpTempChildItem) {
				// Okay, so we have a parent-child link.

				var parent = persistRecall(itemid);
				parent.child = RgtpTempChildItem;
				persistStore(parent);

				var child = persistRecall(RgtpTempChildItem);
				child.parent = itemid;
				persistStore(child);

				RgtpTempChildItem = null;
			} else if (typecode=='M') {
				RgtpVolatile.motd_known = sequence;
			}
		}
		break;

	case 3: // idle state; nothing should happen
		alert('Eh? ' + s);
		break;

	case 4: // just sent ITEM xxx
		if (code=='250') {
			// excellent, here comes the item
			clearItemLines();
			state = 5;
		} else if (code=='410') {
			// no joy
			alert(s);
			state = 3;
		}
		break;

	case 5: // reading an item; in a reply-header
		if (s=='.') {
			calmMeter();
			state = 3;
		} else if (s=='') {
			// end of the header
			addItemLine('', 0);
			state = 6;
		} else {
			addItemLine(s, 1);
		}
		break;

	case 6: // reading an item; not in a reply-header
		if (s=='.') {
			calmMeter();
			state = 3;
		} else if (s.substring(0, 1)=='^') {
			// it's another header
			addItemHorizontalRule();
			state = 5;
		} else {
			addItemLine(s, 0);
		}
		break;

	case 7: // just requested the MOTD
		if (code=='250') {
			RgtpTempMotd = ''
			state = 8;
		} else if (code=='410') {
			alert('There is no Message of the Day today.');
		} // else complain-- fixme
		break;

	case 8: // first line of the MOTD, which we ignore
		state = 9;
		break;

	case 9: // reading the MOTD
		if (s=='.') {
			// all done, hooray
			alert(RgtpTempMotd);

			RgtpVolatile = persistRecall('vol');
			RgtpVolatile.motd_seen = RgtpVolatile.motd_known;
			persistStore(RgtpVolatile);

			RgtpTempMotd = null;
			// everything's back to normal
			state = 3;
		} else if (s=='') {
			RgtpTempMotd = RgtpTempMotd + '\n\n';
		} else {
			RgtpTempMotd = RgtpTempMotd + s + ' ';
		}
		break;

	default: // weird
		alert("Weird state ("+state+")! Eeek! Resetting to safe state.");
		state = 3;
	}
}

partialLines = '';

function handleBlock(b) {
	partialLines = partialLines + b;

	n = 0;

	while (n!=-1) {
		n = partialLines.indexOf('\r\n');
		if (n!=-1) {
			handleLine(partialLines.substring(0, n));
			partialLines = partialLines.substring(n+2);
		}
	}
}

server.onRead = handleBlock;

////////////////////////////////////////////////////////////////
//
// Makes sure we have a vault on disk to cache the index in.

function createVault() {
	// FIXME: Need good error checking all the way through.
	var du = new DirUtils();
	var d = new Dir(du.getMozUserHomeDir());

	if (!d.isDir()) {
		alert("No user directory. You have big problems.");
		return;
	}

	d.append('rgtp-aa');
	if (!d.isDir()) d.create();

	d.append('servers');
	if (!d.isDir()) d.create();

	d.append('1');
	if (!d.isDir()) d.create();

	currentVault = d;
	persistSetDirectory(d);

	// Write out the directions to get to this server.
	// (This is for futureproofing.)
	persistStore({	'host':'rgtp-serv.groggs.group.cam.ac.uk',
			'port': 1431,
			'server': 'groggs',
			'schema': 1,
			'name': 'static' });
}

////////////////////////////////////////////////////////////////

function startup()
{
	createVault();
	server.open();
}

function requestItem(itemid) {
	if (state!=3) {
		alert('Um. Out of phase.');
		return;
	}

	state = 4;
	stripyMeter();
	send('ITEM '+itemid);
}

// FIXME: We need a custom tree object...

function treeSelect(line) {
	if (line==0) return;

	line = line - 1; // Avoid the "groggs" line at the top
			 // (yes, it's horrible)
	var holder = document.getElementById('groggs-items');
	itemid = holder.childNodes.item(line).getAttribute('id').substring(7);
	requestItem(itemid);
}
